<?php
# applet基本接口配置

$domain = '{domain}';

# 登录
$config['applet_login'] = array
(
	'name' => '登录',
	'method' => 'get',
	'json' => false,
	'url' => 'https://api.weixin.qq.com/sns/component/jscode2session?',
	'param' => array
	(
		'appid' => 'appid',
		'js_code' => 'js_code',
		'grant_type' => 'authorization_code',
		'component_appid' => 'component_appid',
		'component_access_token' => 'token',
	),
	'response' => array
	(
		'errmsg' => 'errmsg',
	),
);

# 设置服务域名
$config['applet_domain'] = array
(
	'name' => '设置服务域名',
	'method' => 'post',
	'json' => true,
	'url' => 'https://api.weixin.qq.com/wxa/modify_domain?',
	'param' => array
	(
		'access_token' => 'oauth',
		'action' => 'set',
		'requestdomain' => 'https://' . $domain,
		'wsrequestdomain' => 'wss://' . $domain,
		'uploaddomain' => 'https://' . $domain,
		'downloaddomain' => 'https://' . $domain,
	),
	'response' => array
	(
		'errmsg' => 'errmsg',
	),
);

#设置小程序业务域名
$config['applet_webviewdomain'] = array
(
	'name' => '设置小程序业务域名',
	'method' => 'post',
	'json' => true,
	'url' => 'https://api.weixin.qq.com/wxa/setwebviewdomain?',
	'param' => array
	(
		'access_token' => 'oauth',
		'action' => 'set',
		'webviewdomain' => 'https://' . $domain,
	),
	'response' => array
	(
		'errmsg' => 'errmsg',
	),
);


#设置体验者
$config['applet_tester'] = array
(
	'name' => '设置体验者',
	'method' => 'post',
	'json' => true,
	'url' => 'https://api.weixin.qq.com/wxa/bind_tester?',
	'param' => array
	(
		'access_token' => 'oauth',
		'wechatid' => 'wechatid',
	),
	'response' => array
	(
		'errmsg' => 'errmsg',
	),
);

#删除体验者
$config['applet_untester'] = array
(
	'name' => '删除体验者',
	'method' => 'post',
	'json' => true,
	'url' => 'https://api.weixin.qq.com/wxa/unbind_tester?',
	'param' => array
	(
		'access_token' => 'oauth',
		'wechatid' => 'wechatid',
	),
	'response' => array
	(
		'errmsg' => 'errmsg',
	),
);

#上传小程序代码
$config['applet_commit'] = array
(
	'name' => '上传小程序代码',
	'method' => 'post',
	'json' => true,
	'url' => 'https://api.weixin.qq.com/wxa/commit?',
	'param' => array
	(
		'access_token' => 'oauth',
		'template_id' => 'template_id',
		'ext_json' => 'ext_json',
		'user_version' => 'user_version',
		'user_desc' => 'user_desc',
	),
	'response' => array
	(
		'errmsg' => 'errmsg',
	),
);


#查看体验版二维码
$config['applet_qrcode'] = array
(
	'name' => '查看体验版二维码',
	'method' => 'post',
	'json' => true,
	'url' => 'https://api.weixin.qq.com/wxa/get_qrcode?',
	'param' => array
	(
		'access_token' => 'oauth',
		'path' => 'path',
	),
	'response' => array
	(
		'errmsg' => 'errmsg',
	),
);

$config['applet_submit'] = array
(
	'name' => '将第三方提交的代码包提交审核',
	'method' => 'post',
	'json' => true,
	'url' => 'https://api.weixin.qq.com/wxa/submit_audit?',
	'param' => array
	(
		'access_token' => 'oauth',
		'item_list' => 'item_list',
	),
	'response' => array
	(
		'errmsg' => 'errmsg',
	),
);

$config['applet_category'] = array
(
	'name' => '获取授权小程序帐号的可选类目',
	'method' => 'get',
	'json' => false,
	'url' => 'https://api.weixin.qq.com/wxa/get_category?',
	'param' => array
	(
		'access_token' => 'oauth',
	),
	'response' => array
	(
		'errmsg' => 'errmsg',
	),
);

$config['applet_auditstatus'] = array
(
	'name' => '查询某个指定版本的审核状态',
	'method' => 'post',
	'json' => true,
	'url' => 'https://api.weixin.qq.com/wxa/get_auditstatus?',
	'param' => array
	(
		'access_token' => 'oauth',
		'auditid' => 'auditid',
	),
	'response' => array
	(
		'errmsg' => 'errmsg',
	),
);

$config['applet_publish'] = array
(
	'name' => '发布已通过审核的小程序',
	'method' => 'post',
	'json' => true,
	'url' => 'https://api.weixin.qq.com/wxa/release?',
	'param' => array
	(
		'access_token' => 'oauth',
	),
	'response' => array
	(
		'errmsg' => 'errmsg',
	),
);

$config['applet_revert'] = array
(
	'name' => '小程序版本回退',
	'method' => 'get',
	'json' => false,
	'url' => 'https://api.weixin.qq.com/wxa/revertcoderelease?',
	'param' => array
	(
		'access_token' => 'oauth',
	),
	'response' => array
	(
		'errmsg' => 'errmsg',
	),
);

$config['applet_unaudit'] = array
(
	'name' => '小程序审核撤回',
	'method' => 'get',
	'json' => false,
	'url' => 'https://api.weixin.qq.com/wxa/undocodeaudit?',
	'param' => array
	(
		'access_token' => 'oauth',
	),
	'response' => array
	(
		'errmsg' => 'errmsg',
	),
);


return $config;