<?php

$type = array
(
	1 => '图文',
);

return array
(
	# 表名
	'name' => 'material',
	# 显示给用户看的名称
	'lang' => '素材列表',
	'order' => 100,
	'desc' => '请将material.cron放到cron中，项目选择公众号',

	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> 'ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			'search'	=> 'order',
			//'list'		=> true,
		),

		'project_id'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '项目',
			'default' 	=> '',
			'desc' 		=> '请输入项目',
			'match' 	=> 'is_numeric',
			'list'		=> 'Dever::load("main/project-one#name", {project_id})',
		),

		'type'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '类型',
			'default' 	=> '1',
			'desc' 		=> '类型',
			'match' 	=> 'is_numeric',
			'update'	=> 'select',
			'search'	=> 'select',
			'option'	=> $type,
			'list'		=> true,
		),


		'media_id'		=> array
		(
			'type' 		=> 'varchar-50',
			'name' 		=> '素材id-相同素材id为一组',
			'default' 	=> '',
			'desc' 		=> '素材id',
			'match' 	=> 'is_string',
			//'update'	=> 'text',
			//'list'		=> true,
		),

		'index'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '同组素材的key',
			'default' 	=> '',
			'desc' 		=> '同组素材的key',
			'match' 	=> 'is_string',
			//'update'	=> 'text',
			//'list'		=> true,
		),
		
		'name'		=> array
		(
			'type' 		=> 'varchar-120',
			'name' 		=> '标题-对应微信的title',
			'default' 	=> '',
			'desc' 		=> '标题',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'fulltext',
			'list'		=> '"{name}:{index}"',
			//'modal'		=> '"{name}"',
		),

		'author'		=> array
		(
			'type' 		=> 'varchar-120',
			'name' 		=> '作者',
			'default' 	=> '',
			'desc' 		=> '作者',
			'match' 	=> 'option',
			'update'	=> 'text',
			'list'		=> true,
		),

		'desc'		=> array
		(
			'type' 		=> 'varchar-500',
			'name' 		=> '摘要-对应微信的digest',
			'default' 	=> '',
			'desc' 		=> '摘要',
			'match' 	=> 'option',
			'update'	=> 'textarea',
			//'list'		=> true,
		),

		'url'		=> array
		(
			'type' 		=> 'varchar-500',
			'name' 		=> '链接-微信链接',
			'default' 	=> '',
			'desc' 		=> '链接',
			'match' 	=> 'option',
			'update'	=> 'text',
			//'list'		=> true,
		),

		'content_source_url'		=> array
		(
			'type' 		=> 'varchar-500',
			'name' 		=> '原文页链接',
			'default' 	=> '',
			'desc' 		=> '原文页链接',
			'match' 	=> 'option',
			'update'	=> 'text',
			//'list'		=> true,
		),

		'thumb_media_id'		=> array
		(
			'type' 		=> 'varchar-50',
			'name' 		=> '封面图片素材id',
			'default' 	=> '',
			'desc' 		=> '封面图片素材id',
			'match' 	=> 'is_string',
			//'update'	=> 'text',
			//'list'		=> true,
		),

		'thumb_url'		=> array
		(
			'type' 		=> 'varchar-150',
			'name' 		=> '封面',
			'default' 	=> '',
			'desc' 		=> '请选择封面',
			'match' 	=> 'option',
			'update'	=> 'image',
			'key' 		=> '1',
			'place'		=> '150',
		),

		'content'		=> array
		(
			'type' 		=> 'longtext',
			'name' 		=> '内容',
			'default' 	=> '',
			'desc' 		=> '内容',
			'match' 	=> 'option',
			'update'	=> 'editor',
			//'list'		=> true,
		),

		'update_time'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '更新时间',
			'match' 	=> 'is_numeric',
			'desc' 		=> '',
			'default' 	=> '',
			'list'		=> 'date("Y-m-d H:i:s", {update_time})',
		),

		'create_time'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '创建时间',
			'match' 	=> 'is_numeric',
			'desc' 		=> '',
			'default' 	=> '',
			//'list'		=> 'date("Y-m-d H:i:s", {create_time})',
		),
		
		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '更新时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			'default' 	=> '',
			# 只有insert时才生效
			'insert'	=> true,
			//'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),

	'manage' => array
	(
		//'delete' => false,
		//'insert' => false,
		//'edit' => false,

		'button' => array
		(
			'获取最新图文' => 'service/material.get',
		),
	),
);
