<?php

return array
(
	# 表名
	'name' => 'total_news',
	# 显示给用户看的名称
	'lang' => '统计图文',
	'order' => 19,
	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> 'ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			//'search'	=> 'order',
			'order'		=> 'desc',
			//'list'		=> true,
		),

		'project_id'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '项目',
			'default' 	=> '',
			'desc' 		=> '请输入项目',
			'match' 	=> 'is_numeric',
			'list'		=> 'Dever::load("main/project-one#name", {project_id})',
		),
		
		'day'		=> array
		(
			'type' 		=> 'varchar-60',
			'name' 		=> '日期',
			'default' 	=> '',
			'desc' 		=> '日期',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'fulltext',
			'list'		=> true,
		),

		'daynum'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '日期',
			'default' 	=> '',
			'desc' 		=> '日期',
			'match' 	=> 'is_numeric',
			'update'	=> 'text',
			//'search'	=> 'time',
			//'list'		=> true,
		),

		'msgid'		=> array
		(
			'type' 		=> 'varchar-60',
			'name' 		=> '图文消息id',
			'default' 	=> '0',
			'match' 	=> '图文消息id',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			//'list'		=> true,
		),

		'title'		=> array
		(
			'type' 		=> 'varchar-120',
			'name' 		=> '标题',
			'default' 	=> '0',
			'match' 	=> '标题',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'list'		=> true,
		),

		'int_page_read_user'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '阅读人数',
			'default' 	=> '0',
			'match' 	=> '图文页的阅读人数',
			'match' 	=> 'is_numeric',
			'update'	=> 'text',
			'list'		=> true,
		),

		'int_page_read_count'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '阅读次数',
			'default' 	=> '0',
			'match' 	=> '阅读次数',
			'match' 	=> 'is_numeric',
			'update'	=> 'text',
			'list'		=> true,
		),

		'ori_page_read_user'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '原文阅读人数',
			'default' 	=> '0',
			'match' 	=> '原文阅读人数',
			'match' 	=> 'is_numeric',
			'update'	=> 'text',
			'list'		=> true,
		),

		'ori_page_read_count'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '原文阅读次数',
			'default' 	=> '0',
			'match' 	=> '原文阅读次数',
			'match' 	=> 'is_numeric',
			'update'	=> 'text',
			'list'		=> true,
		),

		'share_user'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '分享人数',
			'default' 	=> '0',
			'match' 	=> '分享人数',
			'match' 	=> 'is_numeric',
			'update'	=> 'text',
			'list'		=> true,
		),

		'share_count'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '分享次数',
			'default' 	=> '0',
			'match' 	=> '分享次数',
			'match' 	=> 'is_numeric',
			'update'	=> 'text',
			'list'		=> true,
		),

		'add_to_fav_user'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '收藏人数',
			'default' 	=> '0',
			'match' 	=> '收藏人数',
			'match' 	=> 'is_numeric',
			'update'	=> 'text',
			'list'		=> true,
		),

		'add_to_fav_count'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '收藏次数',
			'default' 	=> '0',
			'match' 	=> '收藏次数',
			'match' 	=> 'is_numeric',
			'update'	=> 'text',
			'list'		=> true,
		),

		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
			//'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),
	
	'manage' => array
	(
		'insert' => false,
		'edit' => false,
		'delete' => false,
		'excel' => true,
		'button' => array
		(
			'下载昨日统计报表' => array('location', 'service/total.news_out'),
		),
	),

	'request' => array
	(
		'getData' => array
		(
			# 匹配的正则或函数 选填项
			'option' => array
			(
				'day' => 'yes',
				'project_id' => array('yes', 'in'),
				'state' => 1,
			),
			'type' => 'all',
			'col' => '*',
		),
	),
);
