<?php
/*
|--------------------------------------------------------------------------
| material.php 素材管理
|--------------------------------------------------------------------------
*/
namespace Service\Src;

use Dever;
use Main\Lib\Wechat;

class Material extends Base
{
    # 计划任务
    public function cron()
    {
        $project = $this->getProject();
        if ($project) {
            foreach ($project as $k => $v) {
                if ($v) {
                    $base = $this->getList($v);
                }
            }
        }
    }

    /**
     * 获取素材列表
     * 
     * @return mixed
     */
    public function getList($project)
    {
        $day = Dever::input('day', date('Y-m-d', time()-86400));

        $wechat = new Wechat($project, 'service');

        $this->get($day, $wechat);
        
        return 'yes';
    }

    /**
     * 更新素材到数据库中
     * 
     * @return mixed
     */
    private function get($day, $wechat, $offset = 0)
    {
        $param['news'] = 'news';
        $param['offset'] = $offset;
        $param['count'] = 20;

        $data = $wechat->curl('batchget_material', $param, false);

        if ($data && isset($data['item'][0])) {
            $project = $wechat->project();
            foreach ($data['item'] as $k => $v) {
                $this->update($v, $project['id']);
            }

            $this->get($day, $wechat, $offset + $param['count']);
        }
    }

    /**
     * 更新素材到数据库中
     * 
     * @return mixed
     */
    private function update($data, $project)
    {
        if (isset($data['media_id']) && isset($data['content']['news_item'])) {
            $media_id = $data['media_id'];
            $content = $data['content']['news_item'];
            foreach ($content as $k => $v) {
                $this->updateOne($media_id, $project, $k, $v, $data['content']['create_time'], $data['content']['update_time']);
            }
        }
    }

    /**
     * 更新素材到数据库中
     * 
     * @return mixed
     */
    private function updateOne($media_id, $project, $index, $data, $create_time, $update_time)
    {
        $update['media_id'] = $media_id;
        $update['project_id'] = $project;
        $update['index'] = $index;
        $update['name'] = $data['title'];

        $db = Dever::db('service/material');

        $info = $db->one($update);

        $update['type'] = 1;
        $update['author'] = $data['author'];
        $update['desc'] = $data['digest'];
        $update['content'] = $this->content($data['content']);
        $update['url'] = $data['url'];
        $update['content_source_url'] = $data['content_source_url'];
        $update['thumb_media_id'] = $data['thumb_media_id'];
        $update['thumb_url'] = $this->pic($data['thumb_url']);
        $update['update_time'] = $update_time;
        $update['create_time'] = $create_time;

        if ($info) {
            $update['where_id'] = $info['id'];
            $db->update($update);
        } else {
            $db->insert($update);
        }
    }

    /**
     * 图片本地化
     * 
     * @return mixed
     */
    private function pic($pic)
    {
        $pic = Dever::load('upload/save')->copy($pic);

        return $pic['url'];
    }

    /**
     * 内容中的图片本地化
     * 
     * @return mixed
     */
    private function content($content)
    {
        return preg_replace_callback('/<img(.*?) data-src="(.*?)"/i', array($this, 'replace'), $content);
    }

    /**
     * 内容中的图片本地化
     * 
     * @return mixed
     */
    private function replace($matches)
    {
        $result = '';
        if (isset($matches[1])) {
            $data = str_replace(array('"', ' '), array('', '&'), trim($matches[1]));
            parse_str($data, $config);
            $attr = $matches[1];
            if (isset($config['data-w'])) {
                $attr .= ' width="'.$config['data-w'].'"';
            }
            if (isset($config['data-h'])) {
                $attr .= ' height="'.$config['data-h'].'"';
            }
            
            $result = '<img'.$attr.' src="';
        }
        if (isset($matches[2]) && $matches[2]) {
            $result .= $this->pic($matches[2]) . '"';
        }

        return $result;
    }
}